Kean专题(2)-Selection
本帖最后由 作者 于 2009-5-15 11:48:25 编辑原帖:http://through-the-interface.typepad.com/through_the_interface/selection/
一、使实体处于选中状态(与Lisp中SSSetFirst类似的东东)
January 30, 2007
Adding to the AutoCAD pickfirst set with .NET
Back in a much earlier post we looked at some code to access the pickfirst selection set.
I thought I'd now take a look at the more specific case of defining a command that adds entities into the current pickfirst selection set.
Here's some C# code I used to do this, with comments describing its behaviour. The most interesting point is that once we get the contents of the existing pickfirst set we then clear it and rehighlight the entities manually, to give the user a graphical clue of the previous contents.using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Runtime;
namespace SelectionTest
{
public
class
PickfirstTestCmds
{
[CommandMethod("PFA", CommandFlags.Modal |
CommandFlags.UsePickSet |
CommandFlags.Redraw)
]
public
void AddToPickfirstSet()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
// First let's get the initial pickfirst set
PromptSelectionResult sr =
ed.SelectImplied();
// Create a collection containing the initial set
//(could have used an array, but a collection is
//easier in dynamic situations, such as this)
ObjectIdCollection objs;
if (sr.Status == PromptStatus.OK)
objs =
new
ObjectIdCollection(
sr.Value.GetObjectIds()
);
else
objs = new
ObjectIdCollection();
// Clear the pickfirst set...
ed.SetImpliedSelection(new
ObjectId);
// ...but highlight the objects
if (objs.Count > 0)
HighlightEntities(objs);
// No ask the user to select objects
sr = ed.GetSelection();
if (sr.Status == PromptStatus.OK)
{
// Add them all to the collection
foreach (ObjectId obj in sr.Value.GetObjectIds())
{
objs.Add(obj);
}
// Dump the collection to an array
ObjectId[] ids = new
ObjectId;
objs.CopyTo(ids, 0);
// And finally set the pickfirst set
ed.SetImpliedSelection(ids);
}
}
// Highlight the entities by opening them one by one
private
void HighlightEntities(ObjectIdCollection objIds)
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Transaction tr =
doc.TransactionManager.StartTransaction();
using (tr)
{
foreach (ObjectId objId in objIds)
{
Entity ent =
tr.GetObject(objId, OpenMode.ForRead)
as
Entity;
if (ent != null)
ent.Highlight();
}
}
}
}
}
本帖最后由 作者 于 2009-5-17 15:00:19 编辑
二、用选择集选择特定层上的实体
May 02, 2008
Finding all the AutoCAD entities on a particular layer using .NET
This question came in recently by email:
Is there a way to obtain the object IDs of all the object on a layer? I found the GetAllObjects() method of the Transaction object but it doesn't work.
That's right: GetAllObjects() will return the objects accessed via (or added to) the transaction - it has nothing to do with retrieving objects based on any particular property.
What you need to do is Editor.SelectAll(), the equivalent of acedSSGet("X") in ObjectARX and (ssget "X") in AutoLISP. You need the version where you pass in a SelectionFilter specifying the layer for which to search.
Here's some C# code doing just this, with the hard work encapsulated in a function (GetEntitiesOnLayer()) to make it easier to integrate into your code:
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
namespace EntitySelection
{
public class Commands
{
static public void EntitiesOnLayer()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
PromptResult pr =
ed.GetString("\nEnter name of layer: ");
if (pr.Status == PromptStatus.OK)
{
ObjectIdCollection ents =
GetEntitiesOnLayer(pr.StringResult);
ed.WriteMessage(
"\nFound {0} entit{1} on layer {2}",
ents.Count,
(ents.Count == 1 ? "y" : "ies"),
pr.StringResult
);
}
}
private static ObjectIdCollection
GetEntitiesOnLayer(string layerName)
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
// Build a filter list so that only entities
// on the specified layer are selected
TypedValue[] tvs =
new TypedValue {
new TypedValue(
(int)DxfCode.LayerName,
layerName
)
};
SelectionFilter sf =
new SelectionFilter(tvs);
PromptSelectionResult psr =
ed.SelectAll(sf);
if (psr.Status == PromptStatus.OK)
return
new ObjectIdCollection(
psr.Value.GetObjectIds()
);
else
return new ObjectIdCollection();
}
}
}
Running EOL simply counts the entities on a particular layer (the following is from running in the 3D House.dwg sample drawing):Command: EOL
Enter name of layer: A-Beam
Found 1 entity on layer A-Beam
Command: EOL
Enter name of layer: A-Concrete
Found 1 entity on layer A-Concrete
Command: EOL
Enter name of layer: Furniture
Found 14 entities on layer Furniture
Command: EOL
Enter name of layer: Legs
Found 16 entities on layer LegsIt would be straightforward to do something more than just count the results of the GetEntitiesOnLayer() function, of course, or even to adapt the function to filter on other properties.
本帖最后由 作者 于 2009-5-15 15:12:58 编辑 <br /><br /> <p>三、一个图块的自动计数系统</p><p><a href="http://bbs.mjtd.com/forum.php?mod=viewthread&tid=75650">http://bbs.mjtd.com/forum.php?mod=viewthread&tid=75650</a></p><p></p><p></p> May 12, 2008
An automatic numbering system for AutoCAD blocks using .NET - Part 3
In the last post we introduced some additional features to the original post in this series. In this post we take advantage of - and further extend - those features, by allowing deletion, movement and compaction of the numbered objects.
Here's the modified C# code:
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Geometry;
using System.Collections.Generic;
namespace AutoNumberedBubbles
{
public class Commands : IExtensionApplication
{
// Strings identifying the block
// and the attribute name to use
const string blockName = "BUBBLE";
const string attbName = "NUMBER";
// We will use a separate object to
// manage our numbering, and maintain a
// "base" index (the start of the list)
private NumberedObjectManager m_nom;
private int m_baseNumber = 0;
// Constructor
public Commands()
{
m_nom = new NumberedObjectManager();
}
// Functions called on initialization & termination
public void Initialize()
{
try
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
ed.WriteMessage(
"\nLNSLoad numbering settings by analyzing the current drawing" +
"\nDMPPrint internal numbering information" +
"\nBAPCreate bubbles at points" +
"\nBICCreate bubbles at the center of circles" +
"\nMB Move a bubble in the list" +
"\nDB Delete a bubble" +
"\nRBSReorder the bubbles, to close gaps caused by deletion" +
"\nHLBHighlight a particular bubble"
);
}
catch
{ }
}
public void Terminate()
{
}
// Command to extract and display information
// about the internal numbering
public void DumpNumberingInformation()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
m_nom.DumpInfo(ed);
}
// Command to analyze the current document and
// understand which indeces have been used and
// which are currently free
public void LoadNumberingSettings()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Database db = doc.Database;
Editor ed = doc.Editor;
// We need to clear any internal state
// already collected
m_nom.Clear();
m_baseNumber = 0;
// Select all the blocks in the current drawing
TypedValue[] tvs =
new TypedValue {
new TypedValue(
(int)DxfCode.Start,
"INSERT"
)
};
SelectionFilter sf =
new SelectionFilter(tvs);
PromptSelectionResult psr =
ed.SelectAll(sf);
// If it succeeded and we have some blocks...
if (psr.Status == PromptStatus.OK &&
psr.Value.Count > 0)
{
Transaction tr =
db.TransactionManager.StartTransaction();
using (tr)
{
// First get the modelspace and the ID
// of the block for which we're searching
BlockTableRecord ms;
ObjectId blockId;
if (GetBlock(
db, tr, out ms, out blockId
))
{
// For each block reference in the drawing...
foreach (SelectedObject o in psr.Value)
{
DBObject obj =
tr.GetObject(o.ObjectId, OpenMode.ForRead);
BlockReference br = obj as BlockReference;
if (br != null)
{
// If it's the one we care about...
if (br.BlockTableRecord == blockId)
{
// Check its attribute references...
int pos = -1;
AttributeCollection ac =
br.AttributeCollection;
foreach (ObjectId id in ac)
{
DBObject obj2 =
tr.GetObject(id, OpenMode.ForRead);
AttributeReference ar =
obj2 as AttributeReference;
// When we find the attribute
// we care about...
if (ar.Tag == attbName)
{
try
{
// Attempt to extract the number from
// the text string property... use a
// try-catch block just in case it is
// non-numeric
pos =
int.Parse(ar.TextString);
// Add the object at the appropriate
// index
m_nom.NumberObject(
o.ObjectId, pos, false
);
}
catch { }
}
}
}
}
}
}
tr.Commit();
}
// Once we have analyzed all the block references...
int start = m_nom.GetLowerBound(true);
// If the first index is non-zero, ask the user if
// they want to rebase the list to begin at the
// current start position
if (start > 0)
{
ed.WriteMessage(
"\nLowest index is {0}. ",
start
);
PromptKeywordOptions pko =
new PromptKeywordOptions(
"Make this the start of the list?"
);
pko.AllowNone = true;
pko.Keywords.Add("Yes");
pko.Keywords.Add("No");
pko.Keywords.Default = "Yes";
PromptResult pkr =
ed.GetKeywords(pko);
if (pkr.Status == PromptStatus.OK)
{
if (pkr.StringResult == "Yes")
{
// We store our own base number
// (the object used to manage objects
// always uses zero-based indeces)
m_baseNumber = start;
m_nom.RebaseList(m_baseNumber);
}
}
}
}
}
// Command to create bubbles at points selected
// by the user - loops until cancelled
public void BubblesAtPoints()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Database db = doc.Database;
Editor ed = doc.Editor;
Autodesk.AutoCAD.ApplicationServices.
TransactionManager tm =
doc.TransactionManager;
Transaction tr =
tm.StartTransaction();
using (tr)
{
// Get the information about the block
// and attribute definitions we care about
BlockTableRecord ms;
ObjectId blockId;
AttributeDefinition ad;
List<AttributeDefinition> other;
if (GetBlock(
db, tr, out ms, out blockId
))
{
GetBlockAttributes(
tr, blockId, out ad, out other
);
// By default the modelspace is returned to
// us in read-only state
ms.UpgradeOpen();
// Loop until cancelled
bool finished = false;
while (!finished)
{
PromptPointOptions ppo =
new PromptPointOptions("\nSelect point: ");
ppo.AllowNone = true;
PromptPointResult ppr =
ed.GetPoint(ppo);
if (ppr.Status != PromptStatus.OK)
finished = true;
else
// Call a function to create our bubble
CreateNumberedBubbleAtPoint(
db, ms, tr, ppr.Value,
blockId, ad, other
);
tm.QueueForGraphicsFlush();
tm.FlushGraphics();
}
}
tr.Commit();
}
}
// Command to create a bubble at the center of
// each of the selected circles
public void BubblesInCircles()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Database db = doc.Database;
Editor ed = doc.Editor;
// Allow the user to select circles
TypedValue[] tvs =
new TypedValue {
new TypedValue(
(int)DxfCode.Start,
"CIRCLE"
)
};
SelectionFilter sf =
new SelectionFilter(tvs);
PromptSelectionResult psr =
ed.GetSelection(sf);
if (psr.Status == PromptStatus.OK &&
psr.Value.Count > 0)
{
Transaction tr =
db.TransactionManager.StartTransaction();
using (tr)
{
// Get the information about the block
// and attribute definitions we care about
BlockTableRecord ms;
ObjectId blockId;
AttributeDefinition ad;
List<AttributeDefinition> other;
if (GetBlock(
db, tr, out ms, out blockId
))
{
GetBlockAttributes(
tr, blockId, out ad, out other
);
// By default the modelspace is returned to
// us in read-only state
ms.UpgradeOpen();
foreach (SelectedObject o in psr.Value)
{
// For each circle in the selected list...
DBObject obj =
tr.GetObject(o.ObjectId, OpenMode.ForRead);
Circle c = obj as Circle;
if (c == null)
ed.WriteMessage(
"\nObject selected is not a circle."
);
else
// Call our numbering function, passing the
// center of the circle
CreateNumberedBubbleAtPoint(
db, ms, tr, c.Center,
blockId, ad, other
);
}
}
tr.Commit();
}
}
}
// Command to delete a particular bubble
// selected by its index
public void MoveBubble()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
// Use a helper function to select a valid bubble index
int pos =
GetBubbleNumber(
ed,
"\nEnter number of bubble to move: "
);
if (pos >= m_baseNumber)
{
int from = pos - m_baseNumber;
pos =
GetBubbleNumber(
ed,
"\nEnter destination position: "
);
if (pos >= m_baseNumber)
{
int to = pos - m_baseNumber;
ObjectIdCollection ids =
m_nom.MoveObject(from, to);
RenumberBubbles(doc.Database, ids);
}
}
}
// Command to delete a particular bubbler,
// selected by its index
public void DeleteBubble()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Database db = doc.Database;
Editor ed = doc.Editor;
// Use a helper function to select a valid bubble index
int pos =
GetBubbleNumber(
ed,
"\nEnter number of bubble to erase: "
);
if (pos >= m_baseNumber)
{
// Remove the object from the internal list
// (this returns the ObjectId stored for it,
// which we can then use to erase the entity)
ObjectId id =
m_nom.RemoveObject(pos - m_baseNumber);
Transaction tr =
db.TransactionManager.StartTransaction();
using (tr)
{
DBObject obj =
tr.GetObject(id, OpenMode.ForWrite);
obj.Erase();
tr.Commit();
}
}
}
// Command to reorder all the bubbles in the drawing,
// closing all the gaps between numbers but maintaining
// the current numbering order
public void ReorderBubbles()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
// Re-order the bubbles - the IDs returned are
// of the objects that need to be renumbered
ObjectIdCollection ids =
m_nom.ReorderObjects();
RenumberBubbles(doc.Database, ids);
}
// Command to highlight a particular bubble
public void HighlightBubble()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Database db = doc.Database;
Editor ed = doc.Editor;
// Use our function to select a valid bubble index
int pos =
GetBubbleNumber(
ed,
"\nEnter number of bubble to highlight: "
);
if (pos >= m_baseNumber)
{
Transaction tr =
db.TransactionManager.StartTransaction();
using (tr)
{
// Get the ObjectId from the index...
ObjectId id =
m_nom.GetObjectId(pos - m_baseNumber);
if (id == ObjectId.Null)
{
ed.WriteMessage(
"\nNumber is not currently used -" +
" nothing to highlight."
);
return;
}
// And then open & highlight the entity
Entity ent =
(Entity)tr.GetObject(
id,
OpenMode.ForRead
);
ent.Highlight();
tr.Commit();
}
}
}
// Internal helper function to open and retrieve
// the model-space and the block def we care about
private bool
GetBlock(
Database db,
Transaction tr,
out BlockTableRecord ms,
out ObjectId blockId
)
{
BlockTable bt =
(BlockTable)tr.GetObject(
db.BlockTableId,
OpenMode.ForRead
);
if (!bt.Has(blockName))
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
ed.WriteMessage(
"\nCannot find block definition \"" +
blockName +
"\" in the current drawing."
);
blockId = ObjectId.Null;
ms = null;
return false;
}
ms =
(BlockTableRecord)tr.GetObject(
bt,
OpenMode.ForRead
);
blockId = bt;
return true;
}
// Internal helper function to retrieve
// attribute info from our block
// (we return the main attribute def
// and then all the "others")
private void
GetBlockAttributes(
Transaction tr,
ObjectId blockId,
out AttributeDefinition ad,
out List<AttributeDefinition> other
)
{
BlockTableRecord blk =
(BlockTableRecord)tr.GetObject(
blockId,
OpenMode.ForRead
);
ad = null;
other =
new List<AttributeDefinition>();
foreach (ObjectId attId in blk)
{
DBObject obj =
(DBObject)tr.GetObject(
attId,
OpenMode.ForRead
);
AttributeDefinition ad2 =
obj as AttributeDefinition;
if (ad2 != null)
{
if (ad2.Tag == attbName)
{
if (ad2.Constant)
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
ed.WriteMessage(
"\nAttribute to change is constant!"
);
}
else
ad = ad2;
}
else
if (!ad2.Constant)
other.Add(ad2);
}
}
}
// Internal helper function to create a bubble
// at a particular point
private Entity
CreateNumberedBubbleAtPoint(
Database db,
BlockTableRecord btr,
Transaction tr,
Point3d pt,
ObjectId blockId,
AttributeDefinition ad,
List<AttributeDefinition> other
)
{
//Create a new block reference
BlockReference br =
new BlockReference(pt, blockId);
// Add it to the database
br.SetDatabaseDefaults();
ObjectId blockRefId = btr.AppendEntity(br);
tr.AddNewlyCreatedDBObject(br, true);
// Create an attribute reference for our main
// attribute definition (where we'll put the
// bubble's number)
AttributeReference ar =
new AttributeReference();
// Add it to the database, and set its position, etc.
ar.SetDatabaseDefaults();
ar.SetAttributeFromBlock(ad, br.BlockTransform);
ar.Position =
ad.Position.TransformBy(br.BlockTransform);
ar.Tag = ad.Tag;
// Set the bubble's number
int bubbleNumber =
m_baseNumber +
m_nom.NextObjectNumber(blockRefId);
ar.TextString = bubbleNumber.ToString();
ar.AdjustAlignment(db);
// Add the attribute to the block reference
br.AttributeCollection.AppendAttribute(ar);
tr.AddNewlyCreatedDBObject(ar, true);
// Now we add attribute references for the
// other attribute definitions
foreach (AttributeDefinition ad2 in other)
{
AttributeReference ar2 =
new AttributeReference();
ar2.SetAttributeFromBlock(ad2, br.BlockTransform);
ar2.Position =
ad2.Position.TransformBy(br.BlockTransform);
ar2.Tag = ad2.Tag;
ar2.TextString = ad2.TextString;
ar2.AdjustAlignment(db);
br.AttributeCollection.AppendAttribute(ar2);
tr.AddNewlyCreatedDBObject(ar2, true);
}
return br;
}
// Internal helper function to have the user
// select a valid bubble index
private int
GetBubbleNumber(
Editor ed,
string prompt
)
{
int upper = m_nom.GetUpperBound();
if (upper <= 0)
{
ed.WriteMessage(
"\nNo bubbles are currently being managed."
);
return upper;
}
PromptIntegerOptions pio =
new PromptIntegerOptions(prompt);
pio.AllowNone = false;
// Get the limits from our manager object
pio.LowerLimit =
m_baseNumber +
m_nom.GetLowerBound(false);
pio.UpperLimit =
m_baseNumber +
upper;
PromptIntegerResult pir =
ed.GetInteger(pio);
if (pir.Status == PromptStatus.OK)
return pir.Value;
else
return -1;
}
// Internal helper function to open up a list
// of bubbles and reset their number to the
// position in the list
private void RenumberBubbles(
Database db, ObjectIdCollection ids)
{
Transaction tr =
db.TransactionManager.StartTransaction();
using (tr)
{
// Get the block information
BlockTableRecord ms;
ObjectId blockId;
if (GetBlock(
db, tr, out ms, out blockId
))
{
// Open each bubble to be renumbered
foreach (ObjectId bid in ids)
{
if (bid != ObjectId.Null)
{
DBObject obj =
tr.GetObject(bid, OpenMode.ForRead);
BlockReference br = obj as BlockReference;
if (br != null)
{
if (br.BlockTableRecord == blockId)
{
AttributeCollection ac =
br.AttributeCollection;
// Go through its attributes
foreach (ObjectId aid in ac)
{
DBObject obj2 =
tr.GetObject(aid, OpenMode.ForRead);
AttributeReference ar =
obj2 as AttributeReference;
if (ar.Tag == attbName)
{
// Change the one we care about
ar.UpgradeOpen();
int bubbleNumber =
m_baseNumber + m_nom.GetNumber(bid);
ar.TextString =
bubbleNumber.ToString();
break;
}
}
}
}
}
}
}
tr.Commit();
}
}
}
// A generic class for managing groups of
// numbered (and ordered) objects
public class NumberedObjectManager
{
// We need to store a list of object IDs, but
// also a list of free positions in the list
// (this allows numbering gaps)
private List<ObjectId> m_ids;
private List<int> m_free;
// Constructor
public NumberedObjectManager()
{
m_ids =
new List<ObjectId>();
m_free =
new List<int>();
}
// Clear the internal lists
public void Clear()
{
m_ids.Clear();
m_free.Clear();
}
// Return the first entry in the ObjectId list
// (specify "true" if you want to skip
// any null object IDs)
public int GetLowerBound(bool ignoreNull)
{
if (ignoreNull)
// Define an in-line predicate to check
// whether an ObjectId is null
return
m_ids.FindIndex(
delegate(ObjectId id)
{
return id != ObjectId.Null;
}
);
else
return 0;
}
// Return the last entry in the ObjectId list
public int GetUpperBound()
{
return m_ids.Count - 1;
}
// Store the specified ObjectId in the next
// available location in the list, and return
// what that is
public int NextObjectNumber(ObjectId id)
{
int pos;
if (m_free.Count > 0)
{
// Get the first free position, then remove
// it from the "free" list
pos = m_free;
m_free.RemoveAt(0);
m_ids = id;
}
else
{
// There are no free slots (gaps in the numbering)
// so we append it to the list
pos = m_ids.Count;
m_ids.Add(id);
}
return pos;
}
// Go through the list of objects and close any gaps
// by shuffling the list down (easy, as we're using a
// List<> rather than an array)
public ObjectIdCollection ReorderObjects()
{
// Create a collection of ObjectIds we'll return
// for the caller to go and update
// (so the renumbering will gets reflected
// in the objects themselves)
ObjectIdCollection ids =
new ObjectIdCollection();
// We'll go through the "free" list backwards,
// to allow any changes made to the list of
// objects to not affect what we're doing
List<int> rev =
new List<int>(m_free);
rev.Reverse();
foreach (int pos in rev)
{
// First we remove the object at the "free"
// position (in theory this should be set to
// ObjectId.Null, as the slot has been marked
// as blank)
m_ids.RemoveAt(pos);
// Now we go through and add the IDs of any
// affected objects to the list to return
for (int i = pos; i < m_ids.Count; i++)
{
ObjectId id = m_ids;
// Only add non-null objects
// not already in the list
if (!ids.Contains(id) &&
id != ObjectId.Null)
ids.Add(id);
}
}
// Our free slots have been filled, so clear
// the list
m_free.Clear();
return ids;
}
// Get the ID of an object at a particular position
public ObjectId GetObjectId(int pos)
{
if (pos < m_ids.Count)
return m_ids;
else
return ObjectId.Null;
}
// Get the position of an ObjectId in the list
public int GetNumber(ObjectId id)
{
if (m_ids.Contains(id))
return m_ids.IndexOf(id);
else
return -1;
}
// Store an ObjectId in a particular position
// (shuffle == true will "insert" it, shuffling
// the remaining objects down,
// shuffle == false will replace the item in
// that slot)
public void NumberObject(
ObjectId id, int index, bool shuffle)
{
// If we're inserting into the list
if (index < m_ids.Count)
{
if (shuffle)
// Insert takes care of the shuffling
m_ids.Insert(index, id);
else
{
// If we're replacing the existing item, do
// so and then make sure the slot is removed
// from the "free" list, if applicable
m_ids = id;
if (m_free.Contains(index))
m_free.Remove(index);
}
}
else
{
// If we're appending, shuffling is irrelevant,
// but we may need to add additional "free" slots
// if the position comes after the end
while (m_ids.Count < index)
{
m_ids.Add(ObjectId.Null);
m_free.Add(m_ids.LastIndexOf(ObjectId.Null));
m_free.Sort();
}
m_ids.Add(id);
}
}
// Move an ObjectId already in the list to a
// particular position
// (ObjectIds between the two positions will
// get shuffled down automatically)
public ObjectIdCollection MoveObject(
int from, int to)
{
ObjectIdCollection ids =
new ObjectIdCollection();
if (from < m_ids.Count &&
to < m_ids.Count)
{
if (from != to)
{
ObjectId id = m_ids;
m_ids.RemoveAt(from);
m_ids.Insert(to, id);
int start = (from < to ? from : to);
int end = (from < to ? to : from);
for (int i = start; i <= end; i++)
{
ids.Add(m_ids);
}
}
// Now need to adjust/recreate "free" list
m_free.Clear();
for (int j = 0; j < m_ids.Count; j++)
{
if (m_ids == ObjectId.Null)
m_free.Add(j);
}
}
return ids;
}
// Remove an ObjectId from the list
public int RemoveObject(ObjectId id)
{
// Check it's non-null and in the list
if (id != ObjectId.Null &&
m_ids.Contains(id))
{
int pos = m_ids.IndexOf(id);
RemoveObject(pos);
return pos;
}
return -1;
}
// Remove the ObjectId at a particular position
public ObjectId RemoveObject(int pos)
{
// Get the ObjectId in the specified position,
// making sure it's non-null
ObjectId id = m_ids;
if (id != ObjectId.Null)
{
// Null out the position and add it to the
// "free" list
m_ids = ObjectId.Null;
m_free.Add(pos);
m_free.Sort();
}
return id;
}
// Dump out the object list information
// as well as the "free" slots
public void DumpInfo(Editor ed)
{
if (m_ids.Count > 0)
{
ed.WriteMessage("\nIdx ObjectId");
int index = 0;
foreach (ObjectId id in m_ids)
ed.WriteMessage("\n{0} {1}", index++, id);
}
if (m_free.Count > 0)
{
ed.WriteMessage("\n\nFree list: ");
foreach (int pos in m_free)
ed.WriteMessage("{0} ", pos);
}
}
// Remove the initial n items from the list
public void RebaseList(int start)
{
// First we remove the ObjectIds
for (int i=0; i < start; i++)
m_ids.RemoveAt(0);
// Then we go through the "free" list...
int idx = 0;
while (idx < m_free.Count)
{
if (m_free < start)
// Remove any that refer to the slots
// we've removed
m_free.RemoveAt(idx);
else
{
// Subtracting the number of slots
// we've removed from the other items
m_free -= start;
idx++;
}
}
}
}
}The above code defines four new commands which move, delete and highlight a bubble, and reorder the bubble list. I could probably have used better terminology for some of the command-names - the MB (Move Bubble) command does not move the physical position of the block in the drawing, it moves the bubble inside the list (i.e. it changes the bubble's number while maintaining the consistency of the list). Similarly, RBS (Reorder BubbleS) actually just compacts the list, removing unnecessary gaps in the list created by deletion. Anyway, the user is notified of the additional commands by lines 46-50, and the commands themselves are implemented by lines 370-517. MB, DB (Delete Bubble) and HLB (HighLight Bubble) all use a new helper function, GetBubbleNumber(), defined by lines 695-733, which asks the user to select a valid bubble from the list, which will then get moved, deleted or highlighted, as appropriate.
The other new helper function which is defined outside the NumberedObjectManager class (as the function depends on the specific implementation of our object numbering, i.e. with the value stored in an attribute in a block), is RenumberBubbles(), defined by lines 734-800. This function opens up a list of bubbles and sets their visible number to the one stored in the NamedObjectManager object. It is used by both MB and RBS.
To support these new commands, the NamedObjectManager class has also been extended in two new sections of the above code. The first new chunk of code (lines 888-961) implements new methods ReorderObjects() which again, is really a list compaction function and then GetObjectId() and GetNumber(), which - as you'd expect - return an ObjectId at a particular position and a position for a particular ObjectId. The next chunk (lines 1006-1079) implements MoveObject(), which moves an object from one place to another - shuffling the intermediate bubbles around, as needed - and two versions of RemoveObject(), depending on whether you wish to select the object by its ID or its position.
Something important to note about this implementation: so far we haven't dealt with what happens should the user choose to undo these commands: as the objects we're creating are not managed by AutoCAD (they are not stored in the drawing, for instance), their state is not captured in the undo filer, and so will not be affected by undo. But the geometry they refer to will, of course, so there is substantial potential for our list getting out of sync with reality. The easy (and arguably the best) way to get around this is to check for undo-related commands to be executed, and invalidate our list at that point (providing a suitable notification to the user, requesting that they run LNS again once done with their undoing & redoing). The current implementation does not do this.
Let's now take our new commands for a quick spin...
We're going to take our previously-created drawing, as a starting point, and use our new commands on it.
Let's start with DB:Command: LNS
Lowest index is 1. Make this the start of the list? <Yes>: Yes
Command: DB
Enter number of bubble to erase: 3
Command: DB
Enter number of bubble to erase: 5
Command: DB
Enter number of bubble to erase: 15
Command: DB
Enter number of bubble to erase: 16
Command: DMP
Idx ObjectId
0 (2129683752)
1 (2129683776)
2 (0)
3 (2129683824)
4 (0)
5 (2129683872)
6 (2129683896)
7 (2129683920)
8 (2129683944)
9 (2129683968)
10 (2129683992)
11 (2129684016)
12 (2129684040)
13 (2129684064)
14 (0)
15 (0)
16 (2129684136)
17 (2129684160)
18 (2129684184)
19 (2129684208)
Free list: 2 4 14 15
As you can see, we've ended up with a few free slots in our list (and you'll note you need to add our "base number" (1) to get to the visible number). Here's the state of the drawing at this point:
Now let's try MB:Command: MB
Enter number of bubble to move: 7
Enter destination position: 2
Command: DMP
Idx ObjectId
0 (2129683752)
1 (2129683896)
2 (2129683776)
3 (0)
4 (2129683824)
5 (0)
6 (2129683872)
7 (2129683920)
8 (2129683944)
9 (2129683968)
10 (2129683992)
11 (2129684016)
12 (2129684040)
13 (2129684064)
14 (0)
15 (0)
16 (2129684136)
17 (2129684160)
18 (2129684184)
19 (2129684208)
Free list: 3 5 14 15
This results in the item in internal slot 6 being moved to internal slot 1 (remember that base number :-) and the objects between being shuffled along. Here's what's on the screen at this point:
And finally we'll compact the list - removing those four free slots - with our RBS command:Command: RBS
Command: DMP
Idx ObjectId
0 (2129683752)
1 (2129683896)
2 (2129683776)
3 (2129683824)
4 (2129683872)
5 (2129683920)
6 (2129683944)
7 (2129683968)
8 (2129683992)
9 (2129684016)
10 (2129684040)
11 (2129684064)
12 (2129684136)
13 (2129684160)
14 (2129684184)
15 (2129684208)
And here's how that looks:
I don't currently have any further enhancements planned for this application. Feel free to post a comment or send me an email if there's a particular direction in which you'd like to see it go. For instance, is it interesting to see support for prefixes/suffixes...?
May 16, 2008
An automatic numbering system for AutoCAD blocks using .NET - Part 4
In the original post in this series, we introduced a basic application to number AutoCAD objects, specifically blocks with attributes. In the second post we extended this to make use of a generic numbering system for drawing-resident AutoCAD objects, and in the third post we implemented additional commands to take advantage of this new "kernel".
In this post we're going to extend the application in a few ways: firstly we're going to support duplicates, so that the LNS command which parses the current drawing to understand its numbers will support automatic and semi-automatic renumbering of objects with duplicate numbers. In addition there are a number of new event handlers that have been introduced to automatically renumber objects on creation/insertion/copy, and also to clear the numbering system when a user undoes any action in the drawing (just to be safe :-).
While introducing these event handlers I decide to switch the approach for associating data with a drawing: rather than declaring the variables at a class level and assuming they would be duplicated instantiated appropriately per-document, as shown in this previous post, I decided to encapsulate the variables in a class and specifically instantiate that class and store it per-document, as shown in this previous post.
Here's the updated C# code, with the changed & new lines in red, and here is the complete source file to save you having to strip line numbers:
using Autodesk.AutoCAD.ApplicationServices;using Autodesk.AutoCAD.Runtime;using Autodesk.AutoCAD.DatabaseServices;using Autodesk.AutoCAD.EditorInput;using Autodesk.AutoCAD.Geometry;using System.Collections.Generic;using System.Collections;namespace AutoNumberedBubbles{public class Commands : IExtensionApplication{ // Strings identifying the block // and the attribute name to use const string blockName = "BUBBLE"; const string attbName = "NUMBER"; // A string to identify our application's // data in per-document UserData const string dataKey = "TTIFBubbles"; // Define a class for our custom data public class BubbleData { // A separate object to manage our numbering private NumberedObjectManager m_nom; public NumberedObjectManager Nom { get { return m_nom; } } // A "base" index (for the start of the list) private int m_baseNumber; public int BaseNumber { get { return m_baseNumber; } set { m_baseNumber = value; } } // A list of blocks added to the database // which we will then renumber private List<ObjectId> m_blocksAdded; public List<ObjectId> BlocksToRenumber { get { return m_blocksAdded; } } // Constructor public BubbleData() { m_baseNumber = 0; m_nom = new NumberedObjectManager(); m_blocksAdded = new List<ObjectId>(); } // Method to clear the contents public void Reset() { m_baseNumber = 0; m_nom.Clear(); m_blocksAdded.Clear(); } } // Constructor public Commands() { } // Functions called on initialization & termination public void Initialize() { try { DocumentCollection dm = Application.DocumentManager; Document doc = dm.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; ed.WriteMessage( "\nLNSLoad numbering settings by analyzing the current drawing" + "\nDMPPrint internal numbering information" + "\nBAPCreate bubbles at points" + "\nBICCreate bubbles at the center of circles" + "\nMB Move a bubble in the list" + "\nDB Delete a bubble" + "\nRBSReorder the bubbles, to close gaps caused by deletion" + "\nHLBHighlight a particular bubble" ); // Hook into some events, to detect and renumber // blocks added to the database db.ObjectAppended += new ObjectEventHandler( db_ObjectAppended ); dm.DocumentCreated += new DocumentCollectionEventHandler( dm_DocumentCreated ); dm.DocumentLockModeWillChange += new DocumentLockModeWillChangeEventHandler( dm_DocumentLockModeWillChange ); doc.CommandEnded += delegate(object sender, CommandEventArgs e) { if (e.GlobalCommandName == "UNDO" || e.GlobalCommandName == "U") { ed.WriteMessage( "\nUndo invalidates bubble numbering: call" + " LNS to reload the numbers for this drawing" ); GetBubbleData((Document)sender).Reset(); } }; } catch { } } public void Terminate() { } // Method to retrieve (or create) the // BubbleData object for a particular // document private BubbleData GetBubbleData(Document doc) { Hashtable ud = doc.UserData; BubbleData bd = ud as BubbleData; if (bd == null) { object obj = ud; if (obj == null) { // Nothing there bd = new BubbleData(); ud.Add(dataKey, bd); } else { // Found something different instead Editor ed = doc.Editor; ed.WriteMessage( "Found an object of type \"" + obj.GetType().ToString() + "\" instead of BubbleData."); } } return bd; } // Do the same for a particular database private BubbleData GetBubbleData(Database db) { DocumentCollection dm = Application.DocumentManager; Document doc = dm.GetDocument(db); return GetBubbleData(doc); } // When a new document is created, attach our // ObjectAppended event handler to the new // database void dm_DocumentCreated( object sender, DocumentCollectionEventArgs e ) { e.Document.Database.ObjectAppended += new ObjectEventHandler( db_ObjectAppended ); } // When an object is appended to a database, // add it to a list we care about if it's a // BlockReference void db_ObjectAppended( object sender, ObjectEventArgs e ) { BlockReference br = e.DBObject as BlockReference; if (br != null) { BubbleData bd = GetBubbleData(e.DBObject.Database); bd.BlocksToRenumber.Add(br.ObjectId); } } // When the command (or action) is over, // take the list of blocks to renumber and // go through them, renumbering each one void dm_DocumentLockModeWillChange( object sender, DocumentLockModeWillChangeEventArgs e ) { Document doc = e.Document; BubbleData bd = GetBubbleData(doc); if (bd.BlocksToRenumber.Count > 0) { Database db = doc.Database; Transaction tr = db.TransactionManager.StartTransaction(); using (tr) { foreach (ObjectId bid in bd.BlocksToRenumber) { try { BlockReference br = tr.GetObject(bid, OpenMode.ForRead) as BlockReference; if (br != null) { BlockTableRecord btr = (BlockTableRecord)tr.GetObject( br.BlockTableRecord, OpenMode.ForRead ); if (btr.Name == blockName) { AttributeCollection ac = br.AttributeCollection; foreach (ObjectId aid in ac) { DBObject obj = tr.GetObject(aid, OpenMode.ForRead); AttributeReference ar = obj as AttributeReference; if (ar.Tag == attbName) { // Change the one we care about ar.UpgradeOpen(); int bubbleNumber = bd.BaseNumber + bd.Nom.NextObjectNumber(bid); ar.TextString = bubbleNumber.ToString(); break; } } } } } catch { } } tr.Commit(); bd.BlocksToRenumber.Clear(); } } } // Command to extract and display information // about the internal numbering public void DumpNumberingInformation() { Document doc = Application.DocumentManager.MdiActiveDocument; Editor ed = doc.Editor; BubbleData bd = GetBubbleData(doc); bd.Nom.DumpInfo(ed); } // Command to analyze the current document and // understand which indeces have been used and // which are currently free public void LoadNumberingSettings() { Document doc = Application.DocumentManager.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; BubbleData bd = GetBubbleData(doc); // We need to clear any internal state // already collected bd.Reset(); // Select all the blocks in the current drawing TypedValue[] tvs = new TypedValue { new TypedValue( (int)DxfCode.Start, "INSERT" ) }; SelectionFilter sf = new SelectionFilter(tvs); PromptSelectionResult psr = ed.SelectAll(sf); // If it succeeded and we have some blocks... if (psr.Status == PromptStatus.OK && psr.Value.Count > 0) { Transaction tr = db.TransactionManager.StartTransaction(); using (tr) { // First get the modelspace and the ID // of the block for which we're searching BlockTableRecord ms; ObjectId blockId; if (GetBlock( db, tr, out ms, out blockId )) { // For each block reference in the drawing... foreach (SelectedObject o in psr.Value) { DBObject obj = tr.GetObject(o.ObjectId, OpenMode.ForRead); BlockReference br = obj as BlockReference; if (br != null) { // If it's the one we care about... if (br.BlockTableRecord == blockId) { // Check its attribute references... int pos = -1; AttributeCollection ac = br.AttributeCollection; foreach (ObjectId id in ac) { DBObject obj2 = tr.GetObject(id, OpenMode.ForRead); AttributeReference ar = obj2 as AttributeReference; // When we find the attribute // we care about... if (ar.Tag == attbName) { try { // Attempt to extract the number from // the text string property... use a // try-catch block just in case it is // non-numeric pos = int.Parse(ar.TextString); // Add the object at the appropriate // index bd.Nom.NumberObject( o.ObjectId, pos, false, true ); } catch { } } } } } } } tr.Commit(); } // Once we have analyzed all the block references... int start = bd.Nom.GetLowerBound(true); // If the first index is non-zero, ask the user if // they want to rebase the list to begin at the // current start position if (start > 0) { ed.WriteMessage( "\nLowest index is {0}. ", start ); PromptKeywordOptions pko = new PromptKeywordOptions( "Make this the start of the list?" ); pko.AllowNone = true; pko.Keywords.Add("Yes"); pko.Keywords.Add("No"); pko.Keywords.Default = "Yes"; PromptResult pkr = ed.GetKeywords(pko); if (pkr.Status != PromptStatus.OK) bd.Reset(); else { if (pkr.StringResult == "Yes") { // We store our own base number // (the object used to manage objects // always uses zero-based indeces) bd.BaseNumber = start; bd.Nom.RebaseList(bd.BaseNumber); } } } // We found duplicates in the numbering... if (bd.Nom.HasDuplicates()) { // Ask how to fix the duplicates PromptKeywordOptions pko = new PromptKeywordOptions( "Blocks contain duplicate numbers. " + "How do you want to renumber?" ); pko.AllowNone = true; pko.Keywords.Add("Automatically"); pko.Keywords.Add("Individually"); pko.Keywords.Add("Not"); pko.Keywords.Default = "Automatically"; PromptResult pkr = ed.GetKeywords(pko); bool bAuto = false; bool bManual = false; if (pkr.Status != PromptStatus.OK) bd.Reset(); else { if (pkr.StringResult == "Automatically") bAuto = true; else if (pkr.StringResult == "Individually") bManual = true; // Whether fixing automatically or manually // we will iterate through the duplicate list if (bAuto || bManual) { ObjectIdCollection idc = new ObjectIdCollection(); // Get each entry in the duplicate list SortedDictionary<int,List<ObjectId>> dups = bd.Nom.Duplicates; foreach ( KeyValuePair<int,List<ObjectId>> dup in dups ) { // The position is the key in the entry // and the list of IDs is the value // (we take a copy, so we can modify it // without affecting the original) int pos = dup.Key; List<ObjectId> ids = new List<ObjectId>(dup.Value); // For automatic renumbering there's no // user interaction if (bAuto) { foreach (ObjectId id in ids) { bd.Nom.NextObjectNumber(id); idc.Add(id); } } else // bManual { // For manual renumbering we ask the user // to select the block to keep, then // we renumber the rest automatically ed.UpdateScreen(); ids.Add(bd.Nom.GetObjectId(pos)); HighlightBubbles(db, ids, true); ed.WriteMessage( "\n\nHighlighted blocks " + "with number {0}. ", pos + bd.BaseNumber ); bool finished = false; while (!finished) { PromptEntityOptions peo = new PromptEntityOptions( "Select block to keep (others " + "will be renumbered automatically): " ); peo.SetRejectMessage( "\nEntity must be a block." ); peo.AddAllowedClass( typeof(BlockReference), false); PromptEntityResult per = ed.GetEntity(peo); if (per.Status != PromptStatus.OK) { bd.Reset(); return; } else { // A block has been selected, so we // make sure it is one of the ones // we highlighted for the user if (ids.Contains(per.ObjectId)) { // Leave the selected block alone // by removing it from the list ids.Remove(per.ObjectId); // We then renumber each block in // the list foreach (ObjectId id in ids) { bd.Nom.NextObjectNumber(id); idc.Add(id); } RenumberBubbles(db, idc); idc.Clear(); // Let's unhighlight our selected // block (renumbering will do this // for the others) List<ObjectId> redraw = new List<ObjectId>(1); redraw.Add(per.ObjectId); HighlightBubbles(db, redraw, false); finished = true; } else { ed.WriteMessage( "\nBlock selected is not " + "numbered with {0}. ", pos + bd.BaseNumber ); } } } } } RenumberBubbles(db, idc); } bd.Nom.Duplicates.Clear(); ed.UpdateScreen(); } } } } // Take a list of objects and either highlight // or unhighlight them, depending on the flag private void HighlightBubbles( Database db, List<ObjectId> ids, bool highlight) { Transaction tr = db.TransactionManager.StartTransaction(); using (tr) { foreach (ObjectId id in ids) { Entity ent = (Entity)tr.GetObject( id, OpenMode.ForRead ); if (highlight) ent.Highlight(); else ent.Draw(); } tr.Commit(); } } // Command to create bubbles at points selected // by the user - loops until cancelled public void BubblesAtPoints() { Document doc = Application.DocumentManager.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; Autodesk.AutoCAD.ApplicationServices. TransactionManager tm = doc.TransactionManager; Transaction tr = tm.StartTransaction(); using (tr) { // Get the information about the block // and attribute definitions we care about BlockTableRecord ms; ObjectId blockId; AttributeDefinition ad; List<AttributeDefinition> other; if (GetBlock( db, tr, out ms, out blockId )) { GetBlockAttributes( tr, blockId, out ad, out other ); // By default the modelspace is returned to // us in read-only state ms.UpgradeOpen(); // Loop until cancelled bool finished = false; while (!finished) { PromptPointOptions ppo = new PromptPointOptions("\nSelect point: "); ppo.AllowNone = true; PromptPointResult ppr = ed.GetPoint(ppo); if (ppr.Status != PromptStatus.OK) finished = true; else // Call a function to create our bubble CreateNumberedBubbleAtPoint( db, ms, tr, ppr.Value, blockId, ad, other ); tm.QueueForGraphicsFlush(); tm.FlushGraphics(); } } tr.Commit(); } } // Command to create a bubble at the center of // each of the selected circles public void BubblesInCircles() { Document doc = Application.DocumentManager.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; // Allow the user to select circles TypedValue[] tvs = new TypedValue { new TypedValue( (int)DxfCode.Start, "CIRCLE" ) }; SelectionFilter sf = new SelectionFilter(tvs); PromptSelectionResult psr = ed.GetSelection(sf); if (psr.Status == PromptStatus.OK && psr.Value.Count > 0) { Transaction tr = db.TransactionManager.StartTransaction(); using (tr) { // Get the information about the block // and attribute definitions we care about BlockTableRecord ms; ObjectId blockId; AttributeDefinition ad; List<AttributeDefinition> other; if (GetBlock( db, tr, out ms, out blockId )) { GetBlockAttributes( tr, blockId, out ad, out other ); // By default the modelspace is returned to // us in read-only state ms.UpgradeOpen(); foreach (SelectedObject o in psr.Value) { // For each circle in the selected list... DBObject obj = tr.GetObject(o.ObjectId, OpenMode.ForRead); Circle c = obj as Circle; if (c == null) ed.WriteMessage( "\nObject selected is not a circle." ); else // Call our numbering function, passing the // center of the circle CreateNumberedBubbleAtPoint( db, ms, tr, c.Center, blockId, ad, other ); } } tr.Commit(); } } } // Command to delete a particular bubble // selected by its index public void MoveBubble() { Document doc = Application.DocumentManager.MdiActiveDocument; Editor ed = doc.Editor; BubbleData bd = GetBubbleData(doc); // Use a helper function to select a valid bubble index int pos = GetBubbleNumber( ed, bd, "\nEnter number of bubble to move: " ); if (pos >= bd.BaseNumber) { int from = pos - bd.BaseNumber; pos = GetBubbleNumber( ed, bd, "\nEnter destination position: " ); if (pos >= bd.BaseNumber) { int to = pos - bd.BaseNumber; ObjectIdCollection ids = bd.Nom.MoveObject(from, to); RenumberBubbles(doc.Database, ids); } } } // Command to delete a particular bubbler, // selected by its index public void DeleteBubble() { Document doc = Application.DocumentManager.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; BubbleData bd = GetBubbleData(doc); // Use a helper function to select a valid bubble index int pos = GetBubbleNumber( ed, bd, "\nEnter number of bubble to erase: " ); if (pos >= bd.BaseNumber) { // Remove the object from the internal list // (this returns the ObjectId stored for it, // which we can then use to erase the entity) ObjectId id = bd.Nom.RemoveObject(pos - bd.BaseNumber); Transaction tr = db.TransactionManager.StartTransaction(); using (tr) { DBObject obj = tr.GetObject(id, OpenMode.ForWrite); obj.Erase(); tr.Commit(); } } } // Command to reorder all the bubbles in the drawing, // closing all the gaps between numbers but maintaining // the current numbering order public void ReorderBubbles() { Document doc = Application.DocumentManager.MdiActiveDocument; BubbleData bd = GetBubbleData(doc); // Re-order the bubbles - the IDs returned are // of the objects that need to be renumbered ObjectIdCollection ids = bd.Nom.ReorderObjects(); RenumberBubbles(doc.Database, ids); } // Command to highlight a particular bubble public void HighlightBubble() { Document doc = Application.DocumentManager.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; BubbleData bd = GetBubbleData(doc); // Use our function to select a valid bubble index int pos = GetBubbleNumber( ed, bd, "\nEnter number of bubble to highlight: " ); if (pos >= bd.BaseNumber) { ObjectId id = bd.Nom.GetObjectId(pos - bd.BaseNumber); if (id == ObjectId.Null) { ed.WriteMessage( "\nNumber is not currently used -" + " nothing to highlight." ); return; } List<ObjectId> ids = new List<ObjectId>(1); ids.Add(id); HighlightBubbles(db, ids, true); } } // Internal helper function to open and retrieve // the model-space and the block def we care about private bool GetBlock( Database db, Transaction tr, out BlockTableRecord ms, out ObjectId blockId ) { BlockTable bt = (BlockTable)tr.GetObject( db.BlockTableId, OpenMode.ForRead ); if (!bt.Has(blockName)) { Document doc = Application.DocumentManager.MdiActiveDocument; Editor ed = doc.Editor; ed.WriteMessage( "\nCannot find block definition \"" + blockName + "\" in the current drawing." ); blockId = ObjectId.Null; ms = null; return false; } ms = (BlockTableRecord)tr.GetObject( bt, OpenMode.ForRead ); blockId = bt; return true; } // Internal helper function to retrieve // attribute info from our block // (we return the main attribute def // and then all the "others") private void GetBlockAttributes( Transaction tr, ObjectId blockId, out AttributeDefinition ad, out List<AttributeDefinition> other ) { BlockTableRecord blk = (BlockTableRecord)tr.GetObject( blockId, OpenMode.ForRead ); ad = null; other = new List<AttributeDefinition>(); foreach (ObjectId attId in blk) { DBObject obj = (DBObject)tr.GetObject( attId, OpenMode.ForRead ); AttributeDefinition ad2 = obj as AttributeDefinition; if (ad2 != null) { if (ad2.Tag == attbName) { if (ad2.Constant) { Document doc = Application.DocumentManager.MdiActiveDocument; Editor ed = doc.Editor; ed.WriteMessage( "\nAttribute to change is constant!" ); } else ad = ad2; } else if (!ad2.Constant) other.Add(ad2); } } } // Internal helper function to create a bubble // at a particular point private Entity CreateNumberedBubbleAtPoint( Database db, BlockTableRecord btr, Transaction tr, Point3d pt, ObjectId blockId, AttributeDefinition ad, List<AttributeDefinition> other ) { BubbleData bd = GetBubbleData(db); //Create a new block reference BlockReference br = new BlockReference(pt, blockId); // Add it to the database br.SetDatabaseDefaults(); ObjectId blockRefId = btr.AppendEntity(br); tr.AddNewlyCreatedDBObject(br, true); // Create an attribute reference for our main // attribute definition (where we'll put the // bubble's number) AttributeReference ar = new AttributeReference(); // Add it to the database, and set its position, etc. ar.SetDatabaseDefaults(); ar.SetAttributeFromBlock(ad, br.BlockTransform); ar.Position = ad.Position.TransformBy(br.BlockTransform); ar.Tag = ad.Tag; // Set the bubble's number int bubbleNumber = bd.BaseNumber + bd.Nom.NextObjectNumber(blockRefId); ar.TextString = bubbleNumber.ToString(); ar.AdjustAlignment(db); // Add the attribute to the block reference br.AttributeCollection.AppendAttribute(ar); tr.AddNewlyCreatedDBObject(ar, true); // Now we add attribute references for the // other attribute definitions foreach (AttributeDefinition ad2 in other) { AttributeReference ar2 = new AttributeReference(); ar2.SetAttributeFromBlock(ad2, br.BlockTransform); ar2.Position = ad2.Position.TransformBy(br.BlockTransform); ar2.Tag = ad2.Tag; ar2.TextString = ad2.TextString; ar2.AdjustAlignment(db); br.AttributeCollection.AppendAttribute(ar2); tr.AddNewlyCreatedDBObject(ar2, true); } return br; } // Internal helper function to have the user // select a valid bubble index private int GetBubbleNumber( Editor ed, BubbleData bd, string prompt ) { int upper = bd.Nom.GetUpperBound(); if (upper <= 0) { ed.WriteMessage( "\nNo bubbles are currently being managed." ); return upper; } PromptIntegerOptions pio = new PromptIntegerOptions(prompt); pio.AllowNone = false; // Get the limits from our manager object pio.LowerLimit = bd.BaseNumber + bd.Nom.GetLowerBound(false); pio.UpperLimit = bd.BaseNumber + upper; PromptIntegerResult pir = ed.GetInteger(pio); if (pir.Status == PromptStatus.OK) return pir.Value; else return -1; } // Internal helper function to open up a list // of bubbles and reset their number to the // position in the list private void RenumberBubbles( Database db, ObjectIdCollection ids) { BubbleData bd = GetBubbleData(db); Transaction tr = db.TransactionManager.StartTransaction(); using (tr) { // Get the block information BlockTableRecord ms; ObjectId blockId; if (GetBlock( db, tr, out ms, out blockId )) { // Open each bubble to be renumbered foreach (ObjectId bid in ids) { if (bid != ObjectId.Null) { DBObject obj = tr.GetObject(bid, OpenMode.ForRead); BlockReference br = obj as BlockReference; if (br != null) { if (br.BlockTableRecord == blockId) { AttributeCollection ac = br.AttributeCollection; // Go through its attributes foreach (ObjectId aid in ac) { DBObject obj2 = tr.GetObject(aid, OpenMode.ForRead); AttributeReference ar = obj2 as AttributeReference; if (ar.Tag == attbName) { // Change the one we care about ar.UpgradeOpen(); int bubbleNumber = bd.BaseNumber + bd.Nom.GetNumber(bid); ar.TextString = bubbleNumber.ToString(); break; } } } } } } } tr.Commit(); } }}// A generic class for managing groups of// numbered (and ordered) objectspublic class NumberedObjectManager{ // Store the IDs of the objects we're managing private List<ObjectId> m_ids; // A list of free positions in the above list // (allows numbering gaps) private List<int> m_free; // A map of duplicates - blocks detected with // the number of an existing block private SortedDictionary<int,List<ObjectId>> m_dups; public SortedDictionary<int, List<ObjectId>> Duplicates { get { return m_dups; } } // Constructor public NumberedObjectManager() { m_ids = new List<ObjectId>(); m_free = new List<int>(); m_dups = new SortedDictionary<int, List<ObjectId>>(); } // Clear the internal lists public void Clear() { m_ids.Clear(); m_free.Clear(); m_dups.Clear(); } // Does the duplicate list contain anything? public bool HasDuplicates() { return m_dups.Count > 0; } // Return the first entry in the ObjectId list // (specify "true" if you want to skip // any null object IDs) public int GetLowerBound(bool ignoreNull) { if (ignoreNull) // Define an in-line predicate to check // whether an ObjectId is null return m_ids.FindIndex( delegate(ObjectId id) { return id != ObjectId.Null; } ); else return 0; } // Return the last entry in the ObjectId list public int GetUpperBound() { return m_ids.Count - 1; } // Store the specified ObjectId in the next // available location in the list, and return // what that is public int NextObjectNumber(ObjectId id) { int pos; if (m_free.Count > 0) { // Get the first free position, then remove // it from the "free" list pos = m_free; m_free.RemoveAt(0); m_ids = id; } else { // There are no free slots (gaps in the numbering) // so we append it to the list pos = m_ids.Count; m_ids.Add(id); } return pos; } // Go through the list of objects and close any gaps // by shuffling the list down (easy, as we're using a // List<> rather than an array) public ObjectIdCollection ReorderObjects() { // Create a collection of ObjectIds we'll return // for the caller to go and update // (so the renumbering will gets reflected // in the objects themselves) ObjectIdCollection ids = new ObjectIdCollection(); // We'll go through the "free" list backwards, // to allow any changes made to the list of // objects to not affect what we're doing List<int> rev = new List<int>(m_free); rev.Reverse(); foreach (int pos in rev) { // First we remove the object at the "free" // position (in theory this should be set to // ObjectId.Null, as the slot has been marked // as blank) m_ids.RemoveAt(pos); // Now we go through and add the IDs of any // affected objects to the list to return for (int i = pos; i < m_ids.Count; i++) { ObjectId id = m_ids; // Only add non-null objects // not already in the list if (!ids.Contains(id) && id != ObjectId.Null) ids.Add(id); } } // Our free slots have been filled, so clear // the list m_free.Clear(); return ids; } // Get the ID of an object at a particular position public ObjectId GetObjectId(int pos) { if (pos < m_ids.Count) return m_ids; else return ObjectId.Null; } // Get the position of an ObjectId in the list public int GetNumber(ObjectId id) { if (m_ids.Contains(id)) return m_ids.IndexOf(id); else return -1; } // Store an ObjectId in a particular position // (shuffle == true will "insert" it, shuffling // the remaining objects down, // shuffle == false will replace the item in // that slot) public void NumberObject( ObjectId id, int index, bool shuffle, bool dups) { // If we're inserting into the list if (index < m_ids.Count) { if (shuffle) // Insert takes care of the shuffling m_ids.Insert(index, id); else { // If we're replacing the existing item, do // so and then make sure the slot is removed // from the "free" list, if applicable if (!dups || m_ids == ObjectId.Null) { m_ids = id; if (m_free.Contains(index)) m_free.Remove(index); } else { // If we're tracking duplicates, add our new // object to the duplicate list for that index if (dups) { List<ObjectId> ids; if (m_dups.ContainsKey(index)) { ids = m_dups; m_dups.Remove(index); } else ids = new List<ObjectId>(); ids.Add(id); m_dups.Add(index, ids); } } } } else { // If we're appending, shuffling is irrelevant, // but we may need to add additional "free" slots // if the position comes after the end while (m_ids.Count < index) { m_ids.Add(ObjectId.Null); m_free.Add(m_ids.LastIndexOf(ObjectId.Null)); m_free.Sort(); } m_ids.Add(id); } } // Move an ObjectId already in the list to a // particular position // (ObjectIds between the two positions will // get shuffled down automatically) public ObjectIdCollection MoveObject( int from, int to) { ObjectIdCollection ids = new ObjectIdCollection(); if (from < m_ids.Count && to < m_ids.Count) { if (from != to) { ObjectId id = m_ids; m_ids.RemoveAt(from); m_ids.Insert(to, id); int start = (from < to ? from : to); int end = (from < to ? to : from); for (int i = start; i <= end; i++) { ids.Add(m_ids); } } // Now need to adjust/recreate "free" list m_free.Clear(); for (int j = 0; j < m_ids.Count; j++) { if (m_ids == ObjectId.Null) m_free.Add(j); } } return ids; } // Remove an ObjectId from the list public int RemoveObject(ObjectId id) { // Check it's non-null and in the list if (id != ObjectId.Null && m_ids.Contains(id)) { int pos = m_ids.IndexOf(id); RemoveObject(pos); return pos; } return -1; } // Remove the ObjectId at a particular position public ObjectId RemoveObject(int pos) { // Get the ObjectId in the specified position, // making sure it's non-null ObjectId id = m_ids; if (id != ObjectId.Null) { // Null out the position and add it to the // "free" list m_ids = ObjectId.Null; m_free.Add(pos); m_free.Sort(); } return id; } // Dump out the object list information // as well as the "free" slots public void DumpInfo(Editor ed) { if (m_ids.Count > 0) { ed.WriteMessage("\nIdx ObjectId"); int index = 0; foreach (ObjectId id in m_ids) ed.WriteMessage("\n{0} {1}", index++, id); } if (m_free.Count > 0) { ed.WriteMessage("\n\nFree list: "); foreach (int pos in m_free) ed.WriteMessage("{0} ", pos); } if (HasDuplicates()) { ed.WriteMessage("\n\nDuplicate list: "); foreach ( KeyValuePair<int, List<ObjectId>> dup in m_dups ) { int pos = dup.Key; List<ObjectId> ids = dup.Value; ed.WriteMessage("\n{0} ", pos); foreach (ObjectId id in ids) { ed.WriteMessage("{0} ", id); } } } } // Remove the initial n items from the list public void RebaseList(int start) { // First we remove the ObjectIds for (int i=0; i < start; i++) m_ids.RemoveAt(0); // Then we go through the "free" list... int idx = 0; while (idx < m_free.Count) { if (m_free < start) // Remove any that refer to the slots // we've removed m_free.RemoveAt(idx); else { // Subtracting the number of slots // we've removed from the other items m_free -= start; idx++; } } // The duplicate list is more tricky, as we store // our list of objects against the index // (we need to remove and re-add each entry) if (HasDuplicates()) { // First we get all the indeces (which we use // to iterate through the list) SortedDictionary<int, List<ObjectId>>. KeyCollection kc = m_dups.Keys; // Copy the KeyCollection into a list of ints, // to make it easier to iterate // (this also allows us to modify the m_dups // object while we're iterating) List<int> idxs = new List<int>(kc.Count); foreach (int pos in kc) idxs.Add(pos); foreach (int pos in idxs) { List<ObjectId> ids; m_dups.TryGetValue(pos, out ids); if (m_dups.ContainsKey(pos - start)) throw new Exception( ErrorStatus.DuplicateKey, "\nClash detected - " + "duplicate list may be corrupted." ); else { // Remove the old entry and add the new one m_dups.Remove(pos); m_dups.Add(pos - start, ids); } } } }}}As for the specific changes...
Lines 19-71 encapsulate the information we need to store per-document, with lines 140-183 allowing retrieval of this data.
Line 102-130 and 185-289 add event handlers to the application. Note that we watch Database.ObjectAppended event to find when numbered objects are added to a drawing, but we do the actually work of renumbering the objects during DocumentCollection.DocumentLockWillChange - the safe place to do so.
A lot of the additional line changes are simply to access the new per-document data via the BubbleData class: 300-302, 316-317, 322, 402, 418, 452-453, 800-801, 811, 813, 821, 823, 826, 843-844, 854,861, 883-884, 890, 904-905, 915, 1050-1051, 1083-1084, 1124, 1140-1141, 1143, 1161-1162, 1208-1209.
Lines 458-616 add the ability to renumber bubbles while scanning the drawing, whether automatically (with no user intervention) or semi-automatically (allowing the user to choose a specific bubble not to renumber). This latter process uses a new HighlightBubbles() function (lines 620-644) to highlight a list of bubbles (it's generic, so could be called HighlightObjects(), thinking about it). This is then also used by the HLB command, replacing the previous implementation (lines 917-931).
We now pass the BubbleData class through to the GetBubbleNumber() function, in line 1120. This is then used in lines 807, 817, 850 & 911.
The NumberedObjectManager class has required infrastructure changes to support duplicates: 1240-1247, 1259-1260, 1269 & 1272-1277. We're using a SortedDictionary to maintain a list of ObjectIds per position. This is a standard "overflow" data structure, and is only added to when a duplicate is found.
DumpInfo() now displays duplicate data in the DMP command (lines 1571-1590).
RebaseList() has been changed to move entries in the duplicate list. This ended up being quite complicated, as we're mapping a list of objects against a position (the dictionary key) and so it's the key that changes when we move the list's base.
To try out this additional functionality, try this:
Open a drawing with a bunch of bubbles, or create new ones.
Copy & paste these bubbles one or more times, to seed the drawing with duplicate-numbered objects.
Load the application and run the LNS command to understand the numbers in the drawing. Try the different options for renumbering duplicates (Automatically, Individually or Not).
Next try copying and pasting again, once the numbering system is active, and see how the copied numbers are changed.
INSERT a few bubbles: new blocks will also be renumbered - even if the user selects a particular number via the attribute editing dialog - but that's somewhat inevitable with this approach.
OK - now that we're up at nearly 1700 lines of code, it's getting time to bring this series to a close... (or at least to stop including the entire code in each post. :-)
本帖最后由 作者 于 2010-11-15 22:29:09 编辑
四、在选择集中使用条件组合
July 02, 2008
Conditional selection of AutoCAD entities using .NET
This post was inspired by a comment on this previous post, where we looked at some code to select entities on a specific layer. The question was regarding how best to select entities from multiple layers: the selection filtering mechanism inside AutoCAD makes this very easy, and can cope with composition of conditions related to various entity properties.
The basic concept is to enclose sets of entity properties for which you wish to filter with tags indicating the composition of the conditions: for "or" you enclose the conditions with "<or" and "or>" and for "and" you use "<and" and "and>". Wow: I can safely say that that's probably the only sentence I've ever written that has 6 of the last 10 words being "and". :-)
Let's take a concrete example: let's say we want to select all lines on on layer 0 and all the circles with radii greater than 10.'s how we would compose the conditions, in pseudo-code:
<or <and Layer == "0" Entity type == "LINE"and> <and Entity type == "CIRCLE" Radius >= 10.0and>or>This translates into the following C# code - for clarity I've left the specific properties/values hard-coded, but clearly it would be straightforward to ask the user or pick them out of a database, as needed.
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
namespace EntitySelection
{
public class Commands
{
static public void SelectEntitiesWithProperties()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
// Build a conditional filter list so that only
// entities with the specified properties are
// selected
TypedValue[] tvs =
new TypedValue[] {
new TypedValue(
(int)DxfCode.Operator,
"<or"
),
new TypedValue(
(int)DxfCode.Operator,
"<and"
),
new TypedValue(
(int)DxfCode.LayerName,
"0"
),
new TypedValue(
(int)DxfCode.Start,
"LINE"
),
new TypedValue(
(int)DxfCode.Operator,
"and>"
),
new TypedValue(
(int)DxfCode.Operator,
"<and"
),
new TypedValue(
(int)DxfCode.Start,
"CIRCLE"
),
new TypedValue(
(int)DxfCode.Operator,
">="
),
new TypedValue(
(int)DxfCode.Real, // Circle Radius
10.0
),
new TypedValue(
(int)DxfCode.Operator,
"and>"
),
new TypedValue(
(int)DxfCode.Operator,
"or>"
)
};
SelectionFilter sf =
new SelectionFilter(tvs);
PromptSelectionResult psr =
ed.SelectAll(sf);
ed.WriteMessage(
"\nFound {0} entit{1}.",
psr.Value.Count,
(psr.Value.Count == 1 ? "y" : "ies")
);
}
}
}
By the way - you can also choose to perform an "exclusive or" test by using "<xor" and "xor>".
To try out this code, draw a number of lines in a blank drawing, and run the SEWP command. This simply tells you how many entities met the selection criteria - it doesn't leave them selected for use by further commands. You can then see how drawing circles of varying radii changes the number of entities selected by the command.
On a final note... SelectionFilters can be used either non-interactively (as in this example, via the SelectAll() method) or interactively (via GetSelection(), SelectWindow(), SelectCrossingPolygon(), SelectFence(), etc.). I've shown simple uses of SelectionFilters in previous posts, but it's also possible to use quite complicated groupings of conditions - as we've scratched the surface of in this post.
本帖最后由 作者 于 2009-5-17 15:01:42 编辑
五、交换图元特征值
July 07, 2008
Swapping identities of AutoCAD objects using .NET
Everything aches after a very enjoyable soccer tournament in Prague (to which I mentioned I was heading off in my last post). But it was well worth the pain; it was really a lot of fun playing with and against (and just catching up with) so many friends and colleagues.
I received this question a week or so ago by email:
Is there any way to change the handle of an object through the API? Ideally I would like to select two objects and swap the handle.
The code in this post does just that: it asks the user to select two entities, and then swaps their identities (their Handles and ObjectIds), printing some "before & after" information to prove something actually happened.
A quick reminder... please feel free to send through interesting topics by email, but I must stress that these requests will be looked upon only as potential material for blog posts: if you need support related to a specific problem within a particular timeframe, please make use of the public discussion groups or submit your question via the ADN website, if you're a member. In case you're wondering why I'm not available to answer all your questions - something I often wish I could do - I should probably point out that I have a "day job" (managing the worldwide DevTech team) in addition to the time I spend blogging. There simply aren't enough hours in the day for me to do everything, however sad that makes me.
Anyway - back to the topic at hand... at the root of the below code is a single API call: DBObject.SwapIdWith(). Here's what the AutoCAD .NET documentation (found in the ObjectARX SDK, for now), says about the SwapIdWith() function:
This function swaps objectIds and handles between the object specified by otherId and the object invoking this function. Both objects must currently be database-resident and must reside in the same database. If swapExtendedData is true, then the objects swap extended entity data as well. If swapExtensionDictionary is true, then the objects swap extension dictionaries also.
So this function does exactly what was asked: all we then need to do is wrap it up with some code to select the entities and dump their identities to the command-line/text-screen.
Here's the C# code:
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
namespace ObjectIdentity
{
public class Commands
{
static public void SwapEntities()
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
PromptEntityResult per =
ed.GetEntity("\nSelect first entity: ");
if (per.Status != PromptStatus.OK)
return;
ObjectId firstId = per.ObjectId;
per = ed.GetEntity("\nSelect second entity: ");
if (per.Status != PromptStatus.OK)
return;
ObjectId secondId = per.ObjectId;
Transaction tr =
doc.Database.TransactionManager.StartTransaction();
using (tr)
{
DBObject firstObj =
tr.GetObject(firstId, OpenMode.ForRead);
DBObject secondObj =
tr.GetObject(secondId, OpenMode.ForRead);
PrintIdentities(firstObj, secondObj);
PromptKeywordOptions pko =
new PromptKeywordOptions(
"\nSwap their identities?"
);
pko.AllowNone = true;
pko.Keywords.Add("Yes");
pko.Keywords.Add("No");
pko.Keywords.Default = "No";
PromptResult pkr =
ed.GetKeywords(pko);
if (pkr.StringResult == "Yes")
{
try
{
firstObj.UpgradeOpen();
firstObj.SwapIdWith(secondId, true, true);
PrintIdentities(firstObj, secondObj);
}
catch (Exception ex)
{
ed.WriteMessage(
"\nCould not swap identities: " + ex.Message
);
}
}
tr.Commit();
}
}
private static void PrintIdentities(
DBObject first, DBObject second)
{
PrintIdentity(first, "First");
PrintIdentity(second, "Second");
}
private static void PrintIdentity(
DBObject obj, string name)
{
Document doc =
Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;
ed.WriteMessage(
"\n{0} object, of type {1}: " +
"ObjectId is {2}, " +
"Handle is {3}.",
name,
obj.GetType().Name,
obj.ObjectId,
obj.Handle
);
}
}
}
Here's what happens when we run the SE command, selecting a Line and a Circle that have been created in a fresh drawing:Command: SE
Select first entity:
Select second entity:
First object, of type Line: ObjectId is (-1075825472), Handle is 178.
Second object, of type Circle: ObjectId is (-1075825464), Handle is 179.
Swap their identities? <No>: Y
First object, of type Line: ObjectId is (-1075825464), Handle is 179.
Second object, of type Circle: ObjectId is (-1075825472), Handle is 178.So you can see that the handles and object identifiers of the Circle and the Line have been swapped.
Another function you may find useful - if you care about maintaining object identity - is DBObject.HandOverTo(). This allows you to replace a Database-resident object with another, non-Database resident one, maintaining the identity (ObjectId and Handle) of the original. This is useful if you want to implement an operation that modifies an object but has an outcome that's of a different object type. For example, if you break a Circle, you may want to be left with an Arc which has the original Circle's identity. But we'll look at this type of scenario more closely in a future post.
本帖最后由 作者 于 2009-5-15 15:49:47 编辑
对于选择集一直想说说,接着这个帖子说下自己对选择集的理解
1、过滤器利器:
(defun c:dxf() (entget(car(entsel)) '("*")))
实际上过滤器并不复杂,你可以把当前文件看成是一个数据库,这个数据库的所有数据按Dxf组码的形式存储,我们的任务就是按自己的需求组合出不同的条件
2、语法
这一部分自行看帮助的相关内容,以及Dxf帮助
3、注意
范围选择时必须保证该范围可见,否则是选不到东东的
对于特殊的范围选择,比如选择点或文本,可以配合组码10
如
在minpoint和maxpoint两点范围内选择-4,">=,>=,*"
10,minpoint
-4,"<=,<=,*"
10,maxpoint
4、几个例子
a、只选择是数字的text/mtext
0, "*Text",
1, "~*[~.0-9]*",
1, "~*.*.*"b、按线宽选择
public SelectionSet SelectByLineWeight(LineWeight lineWeight)
{
List<TypedValue> filter = new List<TypedValue>();
filter.Add(new TypedValue(370, lineWeight));
OpenLayerTable(OpenMode.ForRead);
List<string> lays = new List<string>();
foreach (ObjectId id in LayerTable)
{
LayerTableRecord ltr = (LayerTableRecord)GetObject(id, OpenMode.ForRead);
if (ltr.LineWeight == lineWeight)
{
lays.Add(ltr.Name);
}
}
if (lays.Count > 0)
{
string s = string.Join(",", lays.ToArray());
filter.Insert(0, new TypedValue(-4, "<or"));
filter.Add(new TypedValue(-4, "<and"));
filter.Add(new TypedValue(8, s));
filter.Add(new TypedValue(370, LineWeight.ByLayer));
filter.Add(new TypedValue(-4, "and>"));
filter.Add(new TypedValue(-4, "or>"));
}
PromptSelectionResult res =CadHelper.Editor.SelectAll(new SelectionFilter(filter.ToArray()));
return res.Value;
}
c、选择曲线
PromptSelectionResult res =
ed.GetSelection(
new PromptSelectionOptions(),
new SelectionFilter(new TypedValue[] {
new TypedValue(0, "*Line,Arc,Circle,Ellipse") }));
页:
[1]